from importlib import metadata

__version__ = metadata.version(__package__)

from .dataclass import (
    DataclassStructInternal,
    DataclassStructProtocol,
    dataclass_struct,
    get_struct_size,
    is_dataclass_struct,
)
from .field import (
    BoolField,
    CharField,
    FloatingPointField,
    IntField,
    NativeIntField,
    PointerField,
    SignedStdIntField,
    SizeField,
    StdIntField,
    UnsignedStdIntField,
)
from .types import (
    F16,
    F32,
    F64,
    I8,
    I16,
    I32,
    I64,
    U8,
    U16,
    U32,
    U64,
    Bool,
    Char,
    Int,
    LengthPrefixed,
    Long,
    LongLong,
    PadAfter,
    PadBefore,
    Pointer,
    Short,
    SignedChar,
    SignedSize,
    UnsignedChar,
    UnsignedInt,
    UnsignedLong,
    UnsignedLongLong,
    UnsignedShort,
    UnsignedSize,
)

__all__ = (
    "F16",
    "F32",
    "F64",
    "I8",
    "I16",
    "I32",
    "I64",
    "U8",
    "U16",
    "U32",
    "U64",
    "Bool",
    "BoolField",
    "Char",
    "CharField",
    "DataclassStructInternal",
    "DataclassStructProtocol",
    "FloatingPointField",
    "Int",
    "IntField",
    "LengthPrefixed",
    "Long",
    "LongLong",
    "NativeIntField",
    "PadAfter",
    "PadBefore",
    "Pointer",
    "PointerField",
    "Short",
    "SignedChar",
    "SignedSize",
    "SignedStdIntField",
    "SizeField",
    "StdIntField",
    "UnsignedChar",
    "UnsignedInt",
    "UnsignedLong",
    "UnsignedLongLong",
    "UnsignedShort",
    "UnsignedSize",
    "UnsignedStdIntField",
    "dataclass_struct",
    "get_struct_size",
    "is_dataclass_struct",
)
